package org.jeecg.modules.stm.rate.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.stm.rate.service.IRateUserscoreService;
import org.jeecg.modules.stm.rate.entity.RateDomainscore;
import org.jeecg.modules.stm.rate.entity.RateUserscore;
import org.jeecg.modules.stm.rate.service.IRateDomainscoreService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 用户分值
 * @Author: jeecg-boot
 * @Date:   2023-10-13
 * @Version: V1.0
 */

@RestController
@RequestMapping("/rate/rateUserscore")
@Slf4j
public class RateUserscoreController extends JeecgController<RateUserscore, IRateUserscoreService> {
	@Autowired
	private IRateUserscoreService rateUserscoreService;

     @Autowired
     private IRateDomainscoreService irateDomainscoreService;
	
	/**
	 * 分页列表查询
	 *
	 * @param rateUserscore
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "用户分值-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<RateUserscore>> queryPageList(RateUserscore rateUserscore,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RateUserscore> queryWrapper = QueryGenerator.initQueryWrapper(rateUserscore, req.getParameterMap());
		Page<RateUserscore> page = new Page<RateUserscore>(pageNo, pageSize);
		IPage<RateUserscore> pageList = rateUserscoreService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param rateUserscore
	 * @return
	 */
	@AutoLog(value = "用户分值-添加")

	//@RequiresPermissions("rate:rate_userscore:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RateUserscore rateUserscore) {
		rateUserscoreService.save(rateUserscore);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param rateUserscore
	 * @return
	 */
	@AutoLog(value = "用户分值-编辑")

	//@RequiresPermissions("rate:rate_userscore:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RateUserscore rateUserscore) {
		rateUserscoreService.updateById(rateUserscore);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "用户分值-通过id删除")

	//@RequiresPermissions("rate:rate_userscore:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		rateUserscoreService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "用户分值-批量删除")

	//@RequiresPermissions("rate:rate_userscore:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.rateUserscoreService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "用户分值-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<RateUserscore> queryById(@RequestParam(name="id",required=true) String id) {
		RateUserscore rateUserscore = rateUserscoreService.getById(id);
		if(rateUserscore==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(rateUserscore);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param rateUserscore
    */
    //@RequiresPermissions("rate:rate_userscore:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RateUserscore rateUserscore) {
        return super.exportXls(request, rateUserscore, RateUserscore.class, "用户分值");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
   // @RequiresPermissions("rate:rate_userscore:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RateUserscore.class);
    }


	 //@AutoLog(value = "用户分值-通过taskid查询")

	 @GetMapping(value = "/queUserScoreByTaskid")
	 public Result<RateUserscore> queUserScoreByTaskid(@RequestParam(name="taskid",required=true) String taskid) {
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 String userid=sysUser.getId();
		 QueryWrapper<RateUserscore> rateUserscoreQueryWrapper = new QueryWrapper<>();
		 rateUserscoreQueryWrapper.eq("rate_task_id",taskid);
		 rateUserscoreQueryWrapper.eq("rate_user",userid);
		 RateUserscore rateUserscore = rateUserscoreService.getOne(rateUserscoreQueryWrapper);


         //从维度分数里取评分到任务表
         QueryWrapper<RateDomainscore> domsoreQueryWrapper = new QueryWrapper<>();
         domsoreQueryWrapper.select("ROUND(SUM(inputscore),2) as inputscore , ROUND(SUM(inputscoreof),2) as inputscoreof ");
         domsoreQueryWrapper.eq("rate_task_id",taskid);
         // domsoreQueryWrapper.in("keyitem_id",key);
         RateDomainscore rmRateSco = irateDomainscoreService.getOne(domsoreQueryWrapper);
         //double totalScore = 100D;
         // double pf = totalScore-rmRateSco.getInputscore();
         double pf = rmRateSco.getInputscore();
         double pfkf = rmRateSco.getInputscoreof();

         rateUserscore.setInputscore(pf);

         rateUserscore.setInputscoreof(pfkf);



		 if(rateUserscore==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(rateUserscore);
	 }

}
